#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_mssql_sumread.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# 06Mar07 BB      - Changed refresh time from 36000 to 36000 
# 08Jan08 BB 2.01 - Added logToFile logic 
# 25Nov10 BB 3.00 - Rewrite for MSSQL
# 24Dec10 BB 3.01 - CHanged refresh from 36000 to 300
# 04Apr11 BB 3.02 - The marquees are annoying - they now scroll only once
# 19Nov11 BB 3.03 - Changed table_width from 750 to 900, and new GADGET code
# 18Jul12 BB 3.04 - Now using $g_detail_heading for all pages 
# =========================================================
$version = "3.04"; 
$debug = 1;
$| = 1;

$P = "dbamon_mssql_sumread";
$log = "/opt/dbamon/log/${P}.log";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";

$mode = uc $ARGV[0];
$modelc = lc $ARGV[0];
$modeucfirst = ucfirst $ARGV[0];

$ticket_reports = 0; 

$table_bgcolor = "bgcolor=wheat"; 
$table_sep     = "<tr bgcolor=white><td colspan=5><hr>\n";

$admin_email = &readRC("Admin_EMail:");
$pscmd = "dbamon_ps"; 

#$rowcolor = "b0e0e6";
#$rowcolor = "dcdcdc";
$rowcolor = "whitesmoke";

#OBSOLETE - $starcolor = "green"; 
$table_width = "900";
$cell_height = "50"; 

$tmp1 = "/tmp/${P}_tmp1.txt"; 

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
#$arg5 = $ARGV[5];
#$arg6 = $ARGV[6];
#$arg7 = $ARGV[7];
#$arg8 = $ARGV[8];

$g_stime = time;

if ($mode ne "TEST" && $mode ne "PROD")
{
  print "$P | Usage: $0 {TEST | PROD}\n";
  exit 1;
}

#---- Program flags
$alpha_make = 0; 
$ora_sby_report = 0; 

#------------------------------------------------------------------------------
sub logToFile
#------------------------------------------------------------------------------
{
  $logfile = "/opt/dbamon/dat/history/health_$modelc.txt"; 
  ##chop($logdate = `date +%Y/%m/%d-%H`);
  $logdate = &getdate;
  &msg("logToFile() Logging to $logfile - logdate=$logdate"); 

  if (system("grep '^$logdate' $logfile 2>&1") == 0)
  {
    &msg("  An entry for logdate=$logdate has already been creating - returning"); 
  }
  else
  {
    &msg("  Creating entry for logdate=$logdate"); 
    open(LOGFILE, ">>$logfile") || &error("Cannot open output $logfile - $!");
    print LOGFILE "$logdate  Health: $health_save  InstanceCount: $health_tot\n"; 
    close(LOGFILE); 
    &msg("Last 3 lines of $logfile");
    system("tail -3 $logfile"); 
  }

  &msg("logToFile() Done"); 
}

#------------------------------------------------------------------------------
sub healthcolors
#------------------------------------------------------------------------------
{
  if    ($health >= 90) { $healthcolor = "#00ff00"; }
  elsif ($health >= 80) { $healthcolor = "#99cc00"; }
  elsif ($health >= 70) { $healthcolor = "#ffff00"; }
  elsif ($health >= 60) { $healthcolor = "#ff9900"; }
  else                  { $healthcolor = "#ff0000"; }
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = $_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=$rowcolor"; 
  }
}

#------------------------------------------------------------------------------
sub bg2
#------------------------------------------------------------------------------
{
  if ($lastbg2 == 1)
  {
    $lastbg2 = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg2 = 1;
    return "bgcolor=$rowcolor"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  ($errmsg,$errorrc,$nomail) = @_;

  ($er_package, $er_filename, $er_line) = caller;
  $callermsg = "Calling er_package=$er_package er_filename=$er_filename er_line=$er_line"; 
  
  &msg("=============================================================");
  &msg("Fatal Error: $errmsg");
  &msg("Caller Info: $callermsg");
  &msg("SQL Error:   $DBI::errstr");  
  &msg("=============================================================");
  &msg("Exiting rc=1");
  $e_time = time - $g_stime;

  system("echo '$callermsg e_time=$e_time $DBI::errstr' | dbamon_mailer -s '$P - $errmsg' $admin_email") unless $nomail;

  if ($errorrc eq "") { exit 1; }
  else                { exit $errorrc; }
}

#-----------------------------------------------------------------------------
sub makeTitle
#-----------------------------------------------------------------------------
{
  &msg("Creating title section");

  print HTML &pageHeaderLocal("Instance Summary - Mode=$modeucfirst", 300); 

  #print HTML "$links";
  #print HTML "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub hourGraph
#-----------------------------------------------------------------------------
{

#  print HTML "
#  <script language='JavaScript'>
#  var is_major = parseInt(navigator.appVersion);
#  var agt      = navigator.userAgent;
#  if (agt.indexOf('IE') == -1)
#  {
#    document.writeln(\"<h2><font color=red>DBAmon WWW Pages Only Look Correct If You Are Using IE</font></h3>  \" );
#  }
#  </script>
#";

  $sql  = "
    select
      --to_char(ts, 'YYYY/MM/DD-HH24'),
      dbamon.dateconvert_19(ts), 
      sev,
      count(*)
    from
      dbamon.event_history
    where
      --ts >= sysdate - 1
      datediff(hour,ts,getdate()) <= 24
      and dbamonmode like 'prod%'
    group by
      --to_char(ts, 'YYYY/MM/DD-HH24'),
      dbamon.dateconvert_19(ts), 
      sev
  ";
  &msg("", "$sql=$sql") if $debug;
  $sth = $dbh->prepare($sql) || &error('sql_100');
  $sth->execute || &error('sql_100');

  $ts_x = -1;

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $sev = $Data[1];
    $cnt = $Data[2];
    ## &msg("ts=$ts sev=$sev cnt=$cnt");

    $ts_x ++;
    push(@ts_list,$ts);
    push(@cn_list,$cnt);

    $total_cnt += $cnt;

    $max_cnt = $cnt if $cnt > $max_cnt;

    $this_dt = (split("-",$ts)) [0];
    $lo_date = $this_dt if $lo_date eq "";
    $hi_date = $this_dt;
  }

  print HTML "<table $table_bgcolor width=$table_width> \n" ;
  print HTML "<tr bgcolor=slate><th colspan=25 $style_med><b>Recent Ticket (Non-Duplicate 'prod' Critical Event) Count - Last 24 Hours</b>\n";
  print HTML "<tr bgcolor=slate><th $style_tiny><b>By Hour<br>(Date: ${lo_date}-${hi_date})<b>\n" ;

  foreach $ts (@ts_list) 
  { 
    $this_ti = (split("-",$ts)) [1];
    print HTML "<th bgcolor=slate><h6>$this_ti\n"; 
  }
  
  print HTML "<tr><th bgcolor=slate><h6>Event Count\n";

  if    ($max_cnt > 200) { $z_factor = 0.25; }
  elsif ($max_cnt > 100) { $z_factor = 0.5; }
  elsif ($max_cnt > 20)  { $z_factor = 1; }
  else                   { $z_factor = 3; }
  
  #foreach $cn (@cn_list) 
  for ($i = 0; $i <= $ts_x; $i++)
  { 
    $this_cn = $cn_list[$i];
    $z = $this_cn * $z_factor;

    if    ($this_cn >= 30) { $color="red"; }
    elsif ($this_cn >= 20) { $color="yellow"; }
    else                   { $color="green"; }

    $dt = $ts_list[$i];

    print HTML "<td align=center valign=bottom><a href='/cgi-bin/dbamon_event_detail.pl?H,$dt'><img src='img/$color.gif' width=15 height=$z></a>\n"; 
  }

  print HTML "<tr bgcolor=slate><th><h6>(Last 24 Hours: $total_cnt)\n";

  foreach $cn (@cn_list) 
  { 
    print HTML "<td align=center><h6>$cn\n"; 
  }

  print HTML "</table><hr> \n" ;
}

#-----------------------------------------------------------------------------
sub dayGraph
#-----------------------------------------------------------------------------
{
  $ daygraph_days = 15;

  $statement  = "
    select
      --to_char(ts, 'YYYY/MM/DD'),
      dbamon.dateconvert_10(ts), 
      sev,
      count(*)
    from
      dbamon.event_history
    where
      --ts >= sysdate - $daygraph_days
      datediff(day,ts,getdate()) <= $daygraph_days
      and dbamonmode like 'prod%'
    group by
      --to_char(ts, 'YYYY/MM/DD'),
      dbamon.dateconvert_10(ts), 
      sev
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  undef @ts_list;
  undef @cn_list;

  $ts_x = -1;

  $max_cnt = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $sev = $Data[1];
    $cnt = $Data[2];
    ## &msg("ts=$ts sev=$sev cnt=$cnt");

    $ts_x ++;
    push(@ts_list,$ts);
    push(@cn_list,$cnt);

    $total_cnt += $cnt;

    $max_cnt = $cnt if $cnt > $max_cnt;

    $this_dt = (split("-",$ts)) [0];
    $lo_date = $this_dt if $lo_date eq "";
    $hi_date = $this_dt;
  }

  print HTML "<table $table_bgcolor width=$table_width> \n" ;
  print HTML "<tr bgcolor=slate><th colspan=19><h5>Recent Ticket (Non-Duplicate 'prod' Critical Event) Count - Last $daygraph_days Days\n";
  print HTML "<tr bgcolor=slate><th><h6>By Date\n" ;

  foreach $ts (@ts_list) 
  { 
    #$this_ti = (split("/",$ts)) [1];
    $this_ti = substr($ts,5);
    print HTML "<th bgcolor=slate><h6>$this_ti\n"; 
  }
  
  print HTML "<tr><th bgcolor=slate><h6>Event Count\n";

  if    ($max_cnt > 1500) { $z_factor = 0.05; }
  elsif ($max_cnt > 1000) { $z_factor = 0.10; }
  elsif ($max_cnt > 250)  { $z_factor = 0.15; }
  else                    { $z_factor = 0.25; }

  print "max_cnt=$max_cnt z_factor=$z_factor\n";
  
  #foreach $cn (@cn_list) 
  for ($i = 0; $i <= $ts_x; $i++)
  { 
    $this_cn = $cn_list[$i];
    $z = int($this_cn * $z_factor);

    if    ($this_cn >= 20*24) { $color="red"; }
    elsif ($this_cn >= 10*24) { $color="yellow"; }
    else                      { $color="green"; }

    $dt = $ts_list[$i];

    print HTML "<td align=center valign=bottom><a href='/cgi-bin/dbamon_event_detail.pl?D,$dt'><img src='img/$color.gif' width=15 height=$z></a>\n"; 
  }

  print HTML "<tr bgcolor=slate><th><h6>(Last 10 Days: $total_cnt)\n";

  foreach $cn (@cn_list) 
  { 
    print HTML "<td align=center><h6>$cn\n"; 
  }

  print HTML "</table><hr> \n" ;
}

#-----------------------------------------------------------------------------
sub emailCopy
#-----------------------------------------------------------------------------
{
  &msg("Updating DBAMON.EMAIL table");

  $statement  = "
    delete from dbamon.email
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->do($statement) || &error('Failed_on_DB_prepare_in_chgEnt');

  $statement  = "
    insert into dbamon.email
      (dbamonmode,
       rmt_hostname,
       rmt_domain,
       rmt_title1,
       dbms,
       dbmsandver,
       id1,
       id2,
       id3,
       id4,
       id5,
       id6,
       id7,
       id8,
       id9,
       id10,
       id11,
       id12,
       id13,
       id14,
       id15,
       id16,
       id17,
       id18,
       id19,
       id20 
      )
    select 
       dbamonmode,
       rmt_hostname,
       rmt_domain,
       rmt_title1,
       dbms,
       dbmsandver,
       id1,
       id2,
       id3,
       id4,  
       id5,  
       id6,  
       id7,  
       id8,  
       id9,  
       id10,
       id11,
       id12,
       id13,
       id14,  
       id15,  
       id16,  
       id17,  
       id18,  
       id19,  
       id20  
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
      and dbms != '(ServerAlias)'
  ";
  ##print "$statement\n";
  $sth = $dbh->do($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
}

#-----------------------------------------------------------------------------
sub makeScoreboard
#-----------------------------------------------------------------------------
{
  &msg("Creating scoreboard section");

  # Count tasks
  $statement  = "
    select 
      count(distinct dbamonmode),
      avg(iter_dur)
    from 
      dbamon.task
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $task_count = $Data[0];
    $task_avgtm = int($Data[1] / 60);
  }

  $statement  = "
    select 
      count(distinct system)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  &msg("  (After select 2)");
  while (@Data = $sth->fetchrow_array)
  {
    $server_count = $Data[0];
  }
  ##print "server_count=$server_count \n";

  # Get total space allocated

  $statement  = "
    select 
      sum(spacealloc) 
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 3)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $total_space = $Data[0];
  }

  $statement  = "
    select 
      count(*)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
      and dbms != '(ServerAlias)'
  ";
  print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 4)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $health_tot = $Data[0];
  }

  $statement  = "
    select 
      count(*)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
      and dbms != '(ServerAlias)'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 5 from summary_detail)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $detail_tot = $Data[0];
  }

  ## $statement  = "select sum(count) from dbamon.summary_tot where text = 'No Events' and dbamonmode like '%${modelc}%'";
  ## ##print "$statement\n";
  ## $sth = $dbh->prepare($statement) || ##         &error('Failed_on_DB_prepare_in_chgEnt');
  ## $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  ## $selectcount = 0;
  ## while (@Data = $sth->fetchrow_array)
  ## {
  ##   $health_good = $Data[0];
  ## }
  ## if ($health_tot > 0) { $health = int(($health_good / $health_tot) * 100); }

  $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and health != -1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $health = int($Data[0]);
    $health = sprintf ("%.1f", $Data[0]);
    print "health=$health\n";
  }

  &healthcolors;
  &msg("DEBUG - health=$health"); 
  $health_save = $health;

  print HTML "<table $table_bgcolor width=$table_width>\n";
  print HTML "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Instance Scoreboard</center></font></b>\n";
  print HTML "</table>\n";

  print HTML "<table $table_bgcolor width=$table_width>\n";
  print HTML "<tr>
    <th bgcolor=slate colspan=4 valign=center $style_head>All Instance <a href='http://dbamon.com/misc/health.shtml'>Health Index</a> (0-100):
    <td bgcolor=$healthcolor width=20%><font face=$font size=6><center>
      <a href='/cgi-bin/dbamon_rpt.pl?$modelc,health'>$health</a>
      </center></font>\n";

  #---- Gadget logic
  $gadget_file = "/opt/dbamon/htm/gadget_$modelc.html";
  open(GADGET, ">$gadget_file") || &error("Cannot open output gadget_file=$gadget_file - $!");

  $ztmp = `cat /opt/dbamon/lib/dbamon_mssql_sumread_inc4.pl`; 
  print GADGET $ztmp; 

  $health_int = int($health); 
  print GADGET "
<tr>
  <td style='border-color:$healthcolor; border-top:thin solid; border-left:thin solid;border-color:$healthcolor;'> 
    <span id='t2'> <b>Global Health: </b> </span></td>
  <td align=right style='border-color:$healthcolor; border-top:thin solid; border-right:thin solid;border-color:$healthcolor;'> 
    <span id='t2'> <a href='$gadget_urlprefix/dbamon_sys.html'> <b> $health_int </b> </a> </span></td>
<tr>
  <td style='border-color:$healthcolor; border-bottom:thin solid; border-left:thin solid;border-color:$healthcolor;'> 
    <span id='t2'> <b>Instances: </b> </span></td>
  <td align=right style='border-color:$healthcolor; border-bottom:thin solid; border-right:thin solid;border-color:$healthcolor;'> 
    <span id='t2'> <a href='$gadget_urlprefix/dbamon_sys.html'> <b> $detail_tot </b> </a> </span></td>

<tr><td colspan=2> <span id='t2'> <b>Outstanding Events:</b> 
  "; 
  #---- <tr><td colspan=2> <span id='t2'> &nbsp; 

  #---- Marquee
  $statement  = "select 
    title, 
    sev,
    count(*) 
  from 
    dbamon.event_history 
  where 
    --ts >= sysdate - 10
    datediff(day,ts,getdate()) <= 10
    --and dbamonmode like 'prod%'
    and dbamonmode like '${modelc}%'
  group by 
    title,
    sev 
  order by 
    3 desc";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $worst_instances = "";
  while (@Data = $sth->fetchrow_array)
  {
    $instance = $Data[0];
    $sev      = $Data[1];
    $count    = $Data[2];
    last if ++$selectcount > 5;   #---- The number of worst WORST instances

    $worst_instances .= "$instance ($sev=$count) ... ";
  }

  print HTML "<tr><td bgcolor=slate align=center $style_tiny><b>Current Status:</b>\n";
  print HTML "<td colspan=3 bgcolor=darkblue align=center $style_tiny><b><font color=wheat><!--#include virtual=\"/dbamon/status_$modelc.txt\"--></font></b>\n";
  print HTML "<td bgcolor=slate>\n";

  $marquee_msg  = "Monitoring $health_tot Instance(s) on $server_count Server(s) - $total_space gB Total DB Space";
  $marquee_msg .= "$task_count DBAmon Task(s) ... ";

  print HTML "<tr><td bgcolor=slate align=center $style_tiny><b>Statistics:</b>\n";
  #print HTML "<td colspan=3><marquee bgcolor=darkblue scrolldelay=10 scrollamount=3 behavior=slide><h6><font color=wheat>$marquee_msg</font></marquee>\n";
  print HTML "<td colspan=3 bgcolor=darkblue $style_tiny><b><font color=wheat>$marquee_msg</b></font>\n";
  print HTML "<td bgcolor=slate>\n";

  $marquee_msg = "$worst_instances ";
  print HTML "<tr><td bgcolor=slate align=center $style_tiny><b>Worst Instances:</b>\n";
  #print HTML "<td colspan=3><marquee bgcolor=darkblue scrolldelay=15 scrollamount=3 behavior=slide><h6><font color=pink>$marquee_msg</font></marquee>\n";
  print HTML "<td colspan=3 bgcolor=darkblue $style_tiny><b><font color=pink>$marquee_msg</b></font>\n";
  print HTML "<td bgcolor=slate align=center nowrap $style_tiny><b>(Last 10 Days 'prod')</b>\n";

  print HTML $table_sep; 

  #---- Graph of critical events during the last 24 hours
  if ($ticket_reports)
  {
    &hourGraph;
    &dayGraph;
  }

  #print HTML "</table>\n";
  #print HTML "<table width=50% border=0>\n";

  print HTML "<tr bgcolor=slate>
    <th colspan=4 $style_head>Outstanding Events By <a href='http://dbamon.com/misc/notify.shtml'>Event Severity</a>:
    <th $style_head>Event Count\n";

  $statement  = "select text, color, sum(count) from dbamon.summary_tot where dbamonmode like '${modelc}%' and text like '%Event%' group by text, color order by 3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $section_tot = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $text   = $Data[0];
    $color  = $Data[1];
    $count  = $Data[2];

    &msg("DEBUG SUMMARY TOT - text=$text count=$count");

    $sev = "";
    $order = "";
    if    ($text =~ /^Critical/) { $sev = "C"; $order = 1; }
    elsif ($text =~ /^Warning/)  { $sev = "W"; $order = 2; }
    elsif ($text =~ /^Info/)     { $sev = "I"; $order = 3; }
    elsif ($text =~ /^User/)     { $sev = "U"; $order = 4; }
    elsif ($text =~ /^Security/) { $sev = "S"; $order = 5; }
    elsif ($text =~ /^Perf/)     { $sev = "P"; $order = 6; }
    elsif ($text =~ /^Notation/) { $sev = "N"; $order = 7; }
    else                         { next; }

    if ($sev ne "")
    {
      $event_type = "<a href='sev_${modelc}.html#${sev}'>$text</a>";
    }
    else
    {
      $event_type = $text;
    }

    # Make is more readable
    # $color = "lime" if $color =~ /green/;

    if ($color =~ /black/ || $color =~ /green/ || $color =~ /blue/ || $color =~ /gray/)
    {
      $order_hash{$order} = "<td bgcolor=$color colspan=4 $style_med><font face=$font color=white><b>$event_type</b></font><td align=right $style_med><b>$count</b> &nbsp; ";
    }
    else
    {
      $order_hash{$order} = "<td bgcolor=$color colspan=4 $style_med><b>$event_type</b><td align=right $style_med><b>$count</b> &nbsp; ";
    }

    if ($sev eq "C" || $sev eq "W" || $sev eq "U" || $sev eq "P" || $sev eq "S") 
    {
      $zfirstword = (split(/\s/,$text)) [0];
      $zfirstword =~ s/Performance/Perf\./; 
   
      if ($count > 0) { $ztr = "bgcolor=darkslateblue"; } 
      else            { $ztr = ""; }

      $gadget_hash{$order} = "<tr $ztr>
  <td align=right> <span id='t2'> <font color=$color> <b> $zfirstword: </b> </font> </span></td>
  <td align=right> <span id='t2'> <b> <a href='$gadget_urlprefix/sev_prod.html#$sev'>$count</b>  </span></td>
      ";
    }

    $selectcount++;
    $section_tot += $count if $text !~ /No Events/;
  }

  @order_keys = sort keys %order_hash;
  foreach $key (@order_keys)
  {
    ##print "key=$key\n";
    $bg = &bg;
    print HTML "<tr $bg>$order_hash{$key} \n";
    if ($gadget_hash{$key})
    {
      print GADGET $gadget_hash{$key}; 
    }
  }

  #---- Gadget finalize
  #<tr><td colspan=2> &nbsp;
  #print GADGET " 
  #<tr>
  #<td colspan=2 align=center> <span id='t3'> As Of: $date </span></td>
  #"; 

  print GADGET "<tr>
    <td colspan=2 align=center> <span id='t3'> As Of: $date </span></td>
  "; 
  $ztmp = `cat /opt/dbamon/lib/dbamon_mssql_sumread_inc5.pl`; 
  print GADGET $ztmp; 
  close GADGET; 

  &msg("Selected $selectcount summary_tot Event rows");
  print HTML "<tr><th colspan=4 bgcolor=slate align=left $style_med>Total Events:
    <th bgcolor=slate align=right $style_med>$section_tot &nbsp; \n";

  print HTML $table_sep; 


  #---- Non-Event Exceptions

  print HTML "<tr bgcolor=slate>
    <td colspan=4 $style_head><b><center>Non-Event Exceptions</center> </b>
    <td $style_head><b><center>Instance Count</center> </b>
    \n";

  $statement  = "select text, color, sum(count) from dbamon.summary_tot where dbamonmode like '${modelc}%' and text not like '%Event%' group by text, color order by 3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $text   = $Data[0];
    $color  = $Data[1];
    $color= "blue" if $color eq "slate   ";
    ##print "color=>$color< \n";
    $count  = $Data[2];
    $bg = &bg;
    if ($color =~ /black/ || $color =~ /green/ || $color =~ /blue/ || $color =~ /gray/)
    {
      print HTML "<tr $bg><td bgcolor=$color colspan=4 $style_med><b><font face=$font color=silver>$text</font></b><td align=right $style_med><b>$count</b> &nbsp; \n";
    }
    else
    {
      print HTML "<tr $bg><td bgcolor=$color colspan=4 $style_med><b>$text</b><td align=right $style_med><b>$count &nbsp;</b> \n";
    }
    $selectcount++;
  }
  &msg("Selected $selectcount summary_tot NO Event rows");

  #---- DBMS Scoreboard

  print HTML $table_sep; 

  #TEST1
  print HTML "</table><table $table_bgcolor width=$table_width>\n";

  print HTML "<tr bgcolor=slate>
    <th $style_head>DBMS/OS/App
    <th $style_head>Instance<br>Count 
    <th $style_head>% Of All<br>Instances
    <th $style_head>Low<br>Version
    <th $style_head>High<br>Version
    <th $style_head>Database<br>Count
    <th $style_head>gB Space<br>Allocated
    \n";

  $statement  = "select dbms, min(v_low), max(v_high), sum(count), sum(db_count), sum(gb_alloc) from dbamon.summary_dbms where dbamonmode like '${modelc}%' group by dbms order by 4 desc";
  print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $dbms   = $Data[0];
    $v_low  = $Data[1];
    $v_high = $Data[2];
    $count  = $Data[3];
    $dbcnt  = $Data[4];
    $gbtot  = $Data[5];

    push(@dbmslist,$dbms);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = int(($count/$detail_tot) * 100); }

    &msg("dbms=$dbms count=$count - detail_tot=$detail_tot pct=$pct");

    if ($dbms eq "Informix-UX     ") { $color = "darkblue" ; }
    if ($dbms eq "OracleDB-UX     ") { $color = "red"      ; }
    if ($dbms eq "OracleApps      ") { $color = "darkred"  ; }
    if ($dbms eq "SAP             ") { $color = "violet"   ; }
    if ($dbms eq "OracleDB-NT     ") { $color = "ff0090"   ; }
    if ($dbms eq "MSSQL           ") { $color = "green"    ; }
    if ($dbms eq "OSWin           ") { $color = "black"    ; }

    $bg = &bg;
    $_ = $dbms;
    s/ //g;
    $dbmslc = lc $_;
    $url = "dbamon_sys_dbms_${dbmslc}_${modelc}.html";

    $gbtot = sprintf("%7.2f",$gbtot);
    $gbtot = "" if $gbtot == 0;

    #---- Remove any leading zeros from v_low/high
    $v_low  = substr($v_low, 1) if $v_low  =~ /^0/;
    $v_high = substr($v_high,1) if $v_high =~ /^0/;

    print HTML "<tr $bg>
      <td $style_med><b><a href='$url'><font face=$font color=$color>$dbms</a></font></b>
      <td align=right $style_med><b>$count</b>
      <td align=right $style_med><b>${pct}%</b>
      <td nowrap $style_med><b><a href='/cgi-bin/dbamon_dbms.pl'>$v_low</a></b>
      <td nowrap $style_med><b><a href='/cgi-bin/dbamon_dbms.pl'>$v_high</a></b>
      <td align=right $style_med><b>$dbcnt   </b>
      <td align=right $style_med><b>$gbtot   </b>
      \n";

    $tot_gbtot += $gbtot;
    $tot_dbcnt += $dbcnt;
  }
  print HTML "
  <tr bgcolor=slate>
    <td $style_head><b>Total ($selectcount Value(s)):</b>
    <td align=right $style_head><b>$tot_count</b>
    <td><td><td></b>
    <td align=right $style_head><b>$tot_dbcnt</b>
    <td align=right $style_head><b>$tot_gbtot</b>
  ";

  $g_tot_dbms = $tot_count;
  &msg("DBMS Scoreboard - tot_count=$tot_count g_tot_dbms=$g_tot_dbms health_tot=$health_tot");

  #TEST1
  print HTML "</table><table width=$table_width>\n";

  if ($health_tot != $g_tot_dbms)
  {
    &error("Killing Myself - health_tot=$health_tot does not match the g_tot_dbms=$g_tot_dbms",2,1); 
  }

  # Check total against DBC file count
  if ($health_tot < ($dbc_count - 5))
  {
    &error("Killing Myself - health_tot=$health_tot is < (dbc_count=$dbc_count - 5)",2,1); 
  }

  &msg("DEBUG - id1_breakout=$id1_breakout"); 

  #---- 2011/01/20 BB - Move this higher up in the scorboard? Hmmm... I'll try it
  print HTML "<hr> <!--#include virtual='$detpath'-->\n";
  print HTML "</table><table $table_bgcolor width=$table_width>\n";

  #---- New IDx Method
  &scoreboardIDVal("ID1")  if $id1_breakout eq "Y";
  &scoreboardIDVal("ID2")  if $id2_breakout eq "Y";
  &scoreboardIDVal("ID3")  if $id3_breakout eq "Y";
  &scoreboardIDVal("ID4")  if $id4_breakout eq "Y";
  &scoreboardIDVal("ID5")  if $id5_breakout eq "Y";
  &scoreboardIDVal("ID6")  if $id6_breakout eq "Y";
  &scoreboardIDVal("ID7")  if $id7_breakout eq "Y";
  &scoreboardIDVal("ID8")  if $id8_breakout eq "Y";
  &scoreboardIDVal("ID9")  if $id9_breakout eq "Y";
  &scoreboardIDVal("ID10") if $id10_breakout eq "Y";
  &scoreboardIDVal("ID11") if $id11_breakout eq "Y";
  &scoreboardIDVal("ID12") if $id12_breakout eq "Y";
  &scoreboardIDVal("ID13") if $id13_breakout eq "Y";
  &scoreboardIDVal("ID14") if $id14_breakout eq "Y";
  &scoreboardIDVal("ID15") if $id15_breakout eq "Y";
  &scoreboardIDVal("ID16") if $id16_breakout eq "Y";
  &msg("DEBUG - ID7B=$id17_breakout"); 
  &scoreboardIDVal("ID17") if $id17_breakout eq "Y";
  &scoreboardIDVal("ID18") if $id18_breakout eq "Y";
  &scoreboardIDVal("ID19") if $id19_breakout eq "Y";
  &scoreboardIDVal("ID20") if $id20_breakout eq "Y";

  #---- Scoreboard by LOC
  &scoreboardLOC if $loc_breakout eq "Y";

  &scoreboardReports ;

  &makeDetailPriSby ;
  &makeDetailBkType ;

  print HTML "</table><hr>\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardLOC
#-----------------------------------------------------------------------------
{
  print HTML $table_sep; 
  print HTML "<tr bgcolor=slate><th colspan=2><h5>Server Network Location<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select 
    --nvl(serverloc,'[Null]'),
    ISNULL(serverloc,'[Null]'),
    count(*) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by serverloc order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $loc   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and ISNULL(serverloc,'[Null]') = '$loc' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "loc=$loc count=$count health=$health\n";

    &healthcolors;

    push(@loclist,$loc);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $loc;
    s/ //g;
    s/\./_/g;
    $loclc = lc $_;
    $url = "dbamon_sys_loc_${loclc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$loc</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "
  <tr bgcolor=slate>
    <td colspan=2 $style_head><b>Total ($selectcount Value(s)):</b>
    <td align=right $style_head><b>$tot_count</b>\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardReports
#-----------------------------------------------------------------------------
{
  print HTML $table_sep; 
  print HTML "<tr bgcolor=slate>
    <th $style_head colspan=2>Misc. Instance Reports
    <th $style_head>Count
  ";

  if ($ora_sby_report)
  {
    $statement  = "select count(*) 
      from dbamon.pri_sby 
      where dbamonmode like '$modelc%'
      ";
    ##print "$statement\n";
    $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    $selectcount = 0;
    $tot_count = 0;
    $lastbg = 0;
    while (@Data = $sth->fetchrow_array)
    {
      $count = $Data[0];
      $selectcount++;
      $bg = &bg;
      $url = "pri_sby_$modelc.html";
      print HTML "<tr $bg>
        <td $style_med colspan=2><b><a href='$url'>Oracle/UX Primary-Standby Pairs</a></b>
        <td $style_med align=right><b>$count </b>\n";
    }
  }

  $bg = &bg;
  print HTML "<tr $bg>
    <td $style_med colspan=2><b><a href='bktype_$modelc.html'>All Instances Backup Type</a></b>
    <td $style_med align=right>\n";

  print HTML "<tr bgcolor=slate>
    <td $style_head colspan=2><b>Total (1 Reports(s)): </b>
    <td $style_head align=right>" ;
}
#-----------------------------------------------------------------------------
sub scoreboardIDVal
#-----------------------------------------------------------------------------
{
  my $thisid = $_[0]; 
  my $thisid_lc = lc $thisid; 

  my $zid = $thisid; 
  $zid =~ s/ID//; 
  my $this_label = &dbamonrcLabel($zid); 
  &msg("zid=$zid $this_label=$this_label"); 

  &msg("-----------------------------------------------------------------------"); 
  &msg("scoreboardIDVal - Starting - thisid=$thisid"); 

  print HTML $table_sep; 
  print HTML "<tr bgcolor=slate>
    <th $style_head colspan=2>$thisid Value: ( $this_label )
    <th $style_head>Instance Count
    <th $style_head>% Of All Instances
    <th $style_head>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>
  ";

  $sql  = "select 
    --nvl($thisid,'[Null]'), 
    ISNULL($thisid,'[Null]'),
    count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by $thisid order by 1";

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;

  while (@Data = $sth->fetchrow_array)
  {
    my $idval = $Data[0];
    $count    = $Data[1];
 
    $selectcount++;

    #---- Get avg health for this IDx value, excluding -1 rows
    $sql  = "select 
      avg(health)
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      -- and nvl($thisid,'[Null]') = '$idval' 
      and ISNULL($thisid,'[Null]') = '$idval'
      and health != -1";
    $sth2 = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##&msg("idval=$idval count=$count health=$health");

    &healthcolors;

    #---- We now call makeDetailIDVal right in this sub, so this is not needed
    ## push(@id1list,$idval);

    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $idval_lc = lc $idval;
    
    $idval_lc =~ s/\//_/g;   #---- Forward slash
    $idval_lc =~ s/\\/_/g;   #---- backward slash
    $idval_lc =~ s/\-/_/g;   #---- hyphen
    $idval_lc =~ s/\s/_/g;   #---- space

    $url = "dbamon_sys_${thisid_lc}_${idval_lc}_${modelc}.html";

    $bg = &bg;
    print HTML "<tr $bg>
      <td $style_med colspan=2><b><a href='$url'><font face=$font>$idval</a></font></b>
      <td $style_med align=right><b>$count</b>
      <td $style_med align=right><b>${pct}%</b>
      <td $style_med align=right bgcolor=$healthcolor><b>${health} </b>
    ";

    #---- Call generic makeDetailIDVal to create the detail page for this IDx VALUE
    &makeDetailIDVal($thisid, $idval); 
  }

  print HTML "<tr bgcolor=slate>
    <td $style_head colspan=2><b>Total ($selectcount Value(s)):</b>
    <td $style_head align=right><b>$tot_count</b>
    <td> &nbsp; 
    <td> &nbsp; 
  " ;
  &msg("scoreboardIDVal - Done"); 
  &msg("-----------------------------------------------------------------------"); 
}

#-----------------------------------------------------------------------------
sub makeDetailIDVal
#-----------------------------------------------------------------------------
{
  my $thisid  = $_[0];
  my $thisval = $_[1];

  ##$thisval       =~ s/ //g; 

  my $thisval_lc =  lc $thisval;
  my $thisid_lc  =  lc $thisid;

  &msg("makeDetailIDVal - Starting - Creating detail section for thisid=$thisid thisid_lc=$thisid_lc thisval=$thisval thisval_lc=$thisval_lc");

  my $thisval_lc_safe =  $thisval_lc;
  $thisval_lc_safe =~ s/\//_/g;   #---- Forward slash
  $thisval_lc_safe =~ s/\\/_/g;   #---- backward slash
  $thisval_lc_safe =~ s/\-/_/g;   #---- hyphen
  $thisval_lc_safe =~ s/\s/_/g;   #---- space
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_${thisid_lc}_${thisval_lc_safe}_${modelc}.html";
  &msg("  htmlfile=$htmlfile"); 
  open(HTMLIDVAL, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLIDVAL &pageHeaderLocal("Instance Summary - $thisid=$thisval - Mode=$modeucfirst"); 

  print HTMLIDVAL "<h5>Report(s):
  <br><li><a href='/cgi-bin/dbamon_rpt.pl?$modelc,IDEvents,$thisid,$thisval'>$thisid=$thisval Event History</a>
  </h5>\n";

  print HTMLIDVAL "<p><span $style_large><b>Instance Detail - $thisid=$thisval Instances:</span></b>\n" ;
  print HTMLIDVAL "<table border=0>\n" ;

  print HTMLIDVAL $g_detail_heading; 

  my $sqlthis = ""; 
  if ($thisval eq "[Null]") { $sqlthis = "is NULL"; }
  else                      { $sqlthis = "= '$thisval'"; }

  my $sql  = "select 
      system, 
      title, 
      dbms, 
      ts, 
      --sysdate-ts,
      --datediff(minute,ts,getdate()) 
      datediff(minute,ts,getdate()),   --HERE
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and $thisid $sqlthis
      and dbms != '(ServerAlias)'
    order by 2
  ";
  $sth2 = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');
  my $selectcount = 0;
  while (@Data = $sth2->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];

    ##$age    = int($Data[4] * (60*24));    #MSSQL - we don't have to Convert to minutes

    $age    = $Data[4];    #MSSQL - don't Convert to minutes

    #$task   = trim($Data[5]);

    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    my $bg2 = &bg2;
    print HTMLIDVAL "<tr $bg2 height=$cell_height> $html <td nowrap $style_tiny><b>$task/$age</b>\n";
    $selectcount++;
  }
  &msg("  Selected $selectcount summary_detail rows for $thisid=$thisval");

  ##print HTMLIDVAL "</form>\n" ;
  print HTMLIDVAL "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLIDVAL "<h5>No Instances Of This $thisid Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLIDVAL "<h5>$selectcount Instance(s) Of This $thisid Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLIDVAL);
  &msg("makeDetailIDVal - Done - thisid=$thisid thisval=$thisval");
}

#-----------------------------------------------------------------------------
sub makeDetailBkType
#-----------------------------------------------------------------------------
{
  $thisdbms = $_[0];
  $_ = $thisdbms;
  s/ //g;
  $thisdbmslc = lc $_;
  $thisdbms = $_;
  &msg("Creating Backup Type report");
  $htmlfile = "/opt/dbamon/htm/bktype_$modelc.html";
  open(HTMLPS, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLPS &pageHeaderLocal("Backup Type Report - Mode=$modeucfirst"); 

  print HTMLPS "<p><h3> Backup Type Report: </h3>\n" ;
  print HTMLPS "<table bgcolor=wheat border=0>\n" ;
  print HTMLPS "<tr bgcolor=slate>
                  <th nowrap>$f_s_med DBMS / Backup Type 
                  <th nowrap>$f_s_med Instance Count
                  \n";

  print HTMLPS "</tr>\n" ;

  $statement  = "
    select 
      dbms, 
      misc1,
      count(*)
    from
      dbamon.instances
    where
      dbamonmode like '${modelc}%'
    group by
      dbms, 
      misc1
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $dbms   = $Data[0];
    $bktype = $Data[1];
    $count  = $Data[2];

    $bktype = "(Null)" if ! $bktype; 
    #print "task=$task age=$age\n";
    #foreach (@Data) { print "rec=$_\n"; }

    $bg = &bg;

    print HTMLPS 
      "<tr $bg zeight=$cell_height> 
        <td nowrap>$f_s_med <b>$dbms / $bktype </b>
        <td align=right nowrap>$f_s_med $count  
    ";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for dbms=$thisdbms");
  close(HTMLPS);
}

#-----------------------------------------------------------------------------
sub makeDetailPriSby
#-----------------------------------------------------------------------------
{
  $thisdbms = $_[0];
  $_ = $thisdbms;
  s/ //g;
  $thisdbmslc = lc $_;
  $thisdbms = $_;
  &msg("Creating PriSby detail report");
  $htmlfile = "/opt/dbamon/htm/pri_sby_$modelc.html";
  open(HTMLPS, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLPS &pageHeaderLocal("Oracle Primary/Standby Report - Mode=$modeucfirst"); 

  print HTMLPS "<p><font face=$font size=3><b>Oracle Primary/Standby Pairs</font></b>\n" ;
  print HTMLPS "<table border=0>\n" ;

  print HTMLPS "<tr bgcolor=slate>
                  <th nowrap><h5>Primary<br> Host 
                  <th nowrap><h5>Primary<br> ORACLE_SID 
                  <th nowrap><h5>Standby<br> Host 
                  <th nowrap><h5>Standby<br> ORACLE_SID 
                  <th nowrap><h5>Most Recent<br>Primary/Standby<br>Timestamp Delta
                  <th nowrap><h5>DBMS
                  <th nowrap><h5>As-Of\n";

  print HTMLPS "</tr>\n" ;

  $statement  = "
    select 
      pri_host,
      pri_sid,
      sby_host,
      sby_sid,
      dbms, 
      mr_delta, 
      --to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\')
      dbamon.dateconvert_19(ts)
    from 
      dbamon.pri_sby 
    where 
      dbamonmode like '${modelc}%' 
    order by 1, 2, 3, 4
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $pri_host = $Data[0];
    $pri_sid  = $Data[1];
    $sby_host = $Data[2];
    $sby_sid  = $Data[3];
    $dbms     = $Data[4];
    $mr_delta = $Data[5];
    $ts       = $Data[6];

    #print "task=$task age=$age\n";
    #foreach (@Data) { print "rec=$_\n"; }

    $bg = &bg;

    print HTMLPS 
      "<tr $bg height=$cell_height> 
        <td nowrap><h5>$pri_host
        <td nowrap><h5>$pri_sid
        <td nowrap><h5>$sby_host
        <td nowrap><h5>$sby_sid
        <td nowrap align=right><h5>$mr_delta
        <td nowrap><h6>$dbms
        <td nowrap><h6>$ts\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for dbms=$thisdbms");

  print HTMLPS "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLPS "<h5>No Primary/Standby Pairs Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLPS "<h5>$selectcount Primary/Standby Pairs Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLPS);
}

#-----------------------------------------------------------------------------
sub makeDetailDBMS
#-----------------------------------------------------------------------------
{
  $thisdbms = $_[0];
  $_ = $thisdbms;
  s/ //g;
  $thisdbmslc = lc $_;
  $thisdbms = $_;
  ##&msg("Creating detail section for dbms=$thisdbms");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_dbms_${thisdbmslc}_${modelc}.html";
  open(HTMLDBMS, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLDBMS &pageHeaderLocal("Instance Summary - DBMS=$thisdbms - Mode=$modeucfirst"); 

  print HTMLDBMS "<p><font face=$font size=3><b>Instance Detail - $thisdbms Instances:</font></b>\n" ;
  print HTMLDBMS "<table border=0>\n" ;

  print HTMLDBMS $g_detail_heading; 

  $statement  = "select 
      system, 
      title, 
      dbms, 
      ts, 
      --sysdate-ts,
      datediff(minute,ts,getdate()),   --HERE
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and dbms = '$thisdbms'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    ##$age    = int($Data[4] * (60*24));    #Convert to minutes -- NOT FOR MSSQL
    $age    = $Data[4];     #MSSQL Now we don't have to Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;
    $html =~ s/<select/\n  <select/g;

    #print "task=$task age=$age\n";
    #foreach (@Data) { print "rec=$_\n"; }

    $bg = &bg;

    print HTMLDBMS "<tr $bg height=$cell_height> $html <td nowrap $style_tiny><b>$task/$age</b>\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for dbms=$thisdbms");

  print HTMLDBMS "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLDBMS "<h5>No Instances Of This DBMS/OS/App Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLDBMS "<h5>$selectcount Instance(s) Of This DBMS/OS/App Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLDBMS);
}

#-----------------------------------------------------------------------------
sub makeDetailLOC
#-----------------------------------------------------------------------------
{
  $thisloc = $_[0];
  $_ = $thisloc;
  s/ //g;
  $thisloc_sql = $_;
  s/\./_/g;
  $thisloclc = lc $_;
  $thisloc = $_;
  &msg("Creating detail section for loc=$thisloc");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_loc_${thisloclc}_${modelc}.html";
  open(HTMLLOC, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLLOC &pageHeaderLocal("Instance Summary - LOC=$thisloc - Mode=$modeucfirst"); 

  print HTMLLOC "<p><font face=$font size=3><b>Instance Detail - Server Network Location=$thisloc_sql Instances:</font></b>\n" ;
  print HTMLLOC "<table border=0>\n" ;

  print HTMLLOC $g_detail_heading; 

  if ($thisloc eq "[Null]") { $sqlloc = "is NULL"; }
  else                      { $sqlloc = "= '$thisloc_sql'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      --sysdate-ts,
      --datediff(minute,ts,getdate()) 
      datediff(minute,ts,getdate()),   --HERE
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and serverloc $sqlloc
      and dbms != '(ServerAlias)'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    ##$age    = int($Data[4] * (60*24));    #Convert to minutes
    $age    = $Data[4];    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLLOC "<tr $bg height=$cell_height> $html <td nowrap $style_tiny><b>$task/$age</b>\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for Server Network Location=$thisloc_sql");

  ##print HTMLLOC "</form>\n" ;
  print HTMLLOC "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLLOC "<h5>No Instances Of This Server Network Location Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLLOC "<h5>$selectcount Instance(s) Of This LOC Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLLOC);
}

#-----------------------------------------------------------------------------
sub instanceDetail
#-----------------------------------------------------------------------------
{
  &msg("instanceDetail() - Creating detail section");
  
  #---- Old
  ##open(HTMLDET, ">/opt/dbamon/htm/$detpath") || &error("Cannot open output $detpath - $!");
  ##print "DEBUG detpath=$detpath\n"; 

  #---- New
  $attempts_max = 4;  
  $! = ""; 
  &msg("Attempting to open output detpath=$detpath"); 
  for ($attempt = 1; $attempt <= $attempts_max; $attempt++)
  { 
    &msg("  Attempt # $attempt - Opening output detpath=$detpath");
    $rc = open(HTMLDET, ">/opt/dbamon/htm/$detpath"); 
    &msg("  After open - rc=$rc \$\!=$!");
    last if $rc == 1 && $! eq ""; 

    if (-e "/bin/fuser") 
    {
      $z = `/bin/fuser -v /opt/dbamon/htm/$detpath 2>&1`;
      open(TMP1, ">$tmp1") || &error("Cannot open output tmp1=$tmp1 - $!");
      print TMP1 "fuser Output for /opt/dbamon/htm/$detpath\n\n"; 
      print TMP1 $z; 
      close(TMP1); 
    }
    else
    {
      open(TMP1, ">$tmp1") || &error("Cannot open output tmp1=$tmp1 - $!");
      print TMP1 "fuser NF\n"; 
      close(TMP1); 
    }
    system("cat $tmp1 | dbamon_mailer -s '$P - Open failure detpath=$detpath attempt=$attempt - Error=$!' $admin_email"); 

    sleep 15;
  }
  if ($! ne "")  
  {
    &error("Cannot open output detpath=$detpath after $attempt attempts - Error=$!"); 
  }
  &msg("Open success - rc=$rc \$\!=$!");

  print HTMLDET "<a name='ALPHA'>\n";
  print HTMLDET "<table $table_bgcolor width=$table_width>\n";
  print HTMLDET "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Instance Detail<br>($detail_tot Instance(s) on $server_count Server(s) - $total_space gB Total Size - DBAmon Tasks: $task_count - Avg. Iteration Time: $task_avgtm Min.)</center></font></b>\n";
  print HTMLDET "</table>\n";

  #print HTMLDET "<font face=$font size=3><b>Instance Detail ($detail_tot Instance(s) on $server_count Server(s) - $total_space gB Total Size - DBAmon Tasks: $task_count - Avg. Iteration Time: $task_avgtm Min.):</font></b>\n" ;

  print HTMLDET "<table $table_bgcolor border=0>\n" ;

  print HTMLDET $g_detail_heading; 

  $sql  = " select 
      system, 
      title, 
      dbms, 
      ts, 
      --sysdate-ts,
      --datediff(minute,ts,getdate()), 
      datediff(minute,ts,getdate()),   --HERE
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
    order by 2 ";
  $sth = $dbh->prepare($sql) || &error("Failed_on_DB_prepare_in_chgEnt - sql=($sql)");
  $sth->execute || &error("Failed_on_DB_execute_in_chgEnt - sql=($sql)");
  $selectcount = 0;
  $lastbg = 0;
  print "DEBUG sql=$sql\n"; 
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    ##$age    = int($Data[4] * (60*24));    #Convert to minutes
    $age    = $Data[4];    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    ##print "FOUND title=$title selectcount=$selectcount \n";

    $bg = &bg;
    print HTMLDET "<tr $bg height=$cell_height> $html <td nowrap $style_tiny><b>$task/$age</b>\n";
    $selectcount++;
    push(@instance_list,$title);
  }
  ##print HTMLDET "</form>\n" ;
  print HTMLDET "</table><hr>\n" ;
  close(HTMLDET);
  &msg("Selected $selectcount summary_detail rows");
}

#-----------------------------------------------------------------------------
sub uptime
#-----------------------------------------------------------------------------
{
  $t = $_[0];
  $statement  = "
    select
      avg(tot_pct)
    from 
      dbamon.uptime_summary
    where 
      instance = '$t'
      --and ts >= sysdate - 30
      and datediff(day,ts,getdate()) <= 30
  ";
  ##print "statement=$statement\n";
  $sth2 = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $color = "lime"; 

  while (@Data = $sth2->fetchrow_array)
  {
    $u = $Data[0];
  }

  $u = int($u);
  $u = sprintf("%5.1f",$u);

  if ($u ne "")
  {
    if    ($u >= 99) { $c = "green"; } 
    elsif ($u >= 95) { $c = "yellow"; } 
    else             { $c = "red"; } 
    $s = "<font color=$c><h5>$u%</font>";
  }
  else 
  {
    $s = "";
  }
  print "t=$t u=$u s=$s \n";
  return $s;
}

#-----------------------------------------------------------------------------
sub makeEventIsolate
#-----------------------------------------------------------------------------
{
  ($this_msgid) = @_;

  if (index($events_processed,$this_msgid) == -1)
  {
    print HTMLEVENT "</table><hr><font size=1>($events_counter Event(s))</font>";
   
    if ($events_optional_text)
    {
      print HTMLEVENT "<br><b><font size=1>($events_optional_text $events_optional_num)</font></b>";
    }

    close(HTMLEVENT);

    $htmlfile = "/opt/dbamon/htm/event_${this_msgid}_${modelc}.html";
    open(HTMLEVENT, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

    print HTMLEVENT &pageHeaderLocal("Instance Summary - Msgid=$this_msgid - Mode=$modeucfirst"); 

    print HTMLEVENT "<table border=0><tr bgcolor=slate><th><h5>MsgID<th><h5>Event Timestamp<th><h5>DBMS<th><h5>Event Text\n";
    
    $events_processed .= "$this_msgid ";
    $events_counter = 0;
    $events_optional_text = "";
    $events_optional_num  = 0;

    $isolated_urls .= "<a href='/dbamon/event_${this_msgid}_${modelc}.html'><b>$this_msgid</b></a> ";
  }

  $events_counter++;
  print HTMLEVENT "$eventline";

  if ($this_msgid eq "DBA313")
  {
    $events_optional_text = "Total gB Saved: " if !$events_optional_text; 
    $znum = (split(" ",$eventline)) [25];
    $events_optional_num += $znum if $znum > 0;
    ##print "znum=$znum events_optional_num=$events_optional_num\n";
  }

}

#-----------------------------------------------------------------------------
sub makeSev
#-----------------------------------------------------------------------------
{
  $htmlfile = "/opt/dbamon/htm/sev_${modelc}.html";
  open(HTMLSEV, ">$htmlfile") || &error("Cannot open output $htmlfile - $!");

  print HTMLSEV &pageHeaderLocal("Instance Outstanding Event Detail - Mode=$modeucfirst"); 

  @sev_list = ("C","W","I","U","S","P","N");
  %sev_colors = ("C" , "red",
                 "W" , "yellow",
                 "I" , "slateblue",
                 "U" , "lime",
                 "S" , "mediumpurple",
                 "P" , "lightskyblue",
                 "N" , "lime"
                );
  %sev_text   = ("C" , "Critical",
                 "W" , "Warning",
                 "I" , "Info",
                 "U" , "User",
                 "S" , "Security",
                 "P" , "Performance",
                 "N" , "Notation"
                );

  foreach $sev (@sev_list)
  {
    ##print "sev=$sev\n";
    print HTMLSEV "<a name='$sev'</a>\n";
    print HTMLSEV "<h4>Severity <font color=$sev_colors{$sev}>$sev</font> $sev_text{$sev} Events</h4>\n";
    print HTMLSEV "<table border=0><tr bgcolor=slate><th><h5>MsgID<th><h5>Event Timestamp<th><h5>DBMS<th><h5>Event Text\n";
    $statement  = "
      select
        system,
        title,
        dbms,
        text,
        msgid,
        details_url,
        --to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\'),
        dbamon.dateconvert_19(ts),
        ticket
      from 
	dbamon.event_detail
      where 
        dbamonmode like '${modelc}%' and
	sev = '$sev'
      order by 
        msgid,
        system,
        --to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\') 
        dbamon.dateconvert_19(ts)
      desc";
    ##print "statement=$statement\n";
    $sth2 = $dbh->prepare($statement) ||
	    &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

    $last_msgid = "";
    $counter = 0;
    $lastbg2 = 0;

    while (@Data = $sth2->fetchrow_array)
    {
      #$system   = $Data[0];
      $instance = $Data[1];
      $dbms     = $Data[2];
      $text     = $Data[3];
      $msgid    = $Data[4];
      $url      = $Data[5];
      $detts    = $Data[6];
      $ticket   = $Data[7];

      next if $msgid eq "DBA301";

      ##print "text=$text\n";

      if ($dbms eq "Informix-UX") { $dbms_color = "darkblue" ; }
      if ($dbms eq "OracleDB-UX") { $dbms_color = "red"      ; }
      if ($dbms eq "OracleApps") { $dbms_color = "darkred"  ; }
      if ($dbms eq "SAP") { $dbms_color = "violet"   ; }
      if ($dbms eq "OracleDB-NT") { $dbms_color = "ff0090"   ; }
      if ($dbms eq "MSSQL") { $dbms_color = "green"    ; }
      if ($dbms eq "OSWin") { $dbms_color = "black"    ; }

      if ($msgid ne $last_msgid && $last_msgid ne "")
      {
        print HTMLSEV "<tr><td><hr size=1>\n";
        $lastbg2 = 0;
      }

      if ($ticket eq "" || $ticket eq "?")
      {
        $ticket = "N/A";
      }

      # temp - until i fix the ticket problem
      #$ticket = "";

      $bg2 = &bg2;

      $eventline = "<tr $bg2>
        <td $style_med bgcolor=$sev_colors{$sev}><b><a HREF='http://dbamon.com/errors.shtml#$msgid'>$msgid</a>
        <td $style_med nowrap><b>$detts </b>
        <td $style_med nowrap><b><font color=$dbms_color>$dbms</font>
        <td $style_med><a href='$url'><b>$text</a> \n";

      print HTMLSEV "$eventline";

      if (index($events_isolate,$msgid) > -1)
      {
        ##print "calling eventisolate $msgid\n";
        &makeEventIsolate($msgid);  
      }

      $counter++;

      $last_msgid = $msgid;
    }
    print HTMLSEV "</table>";
    print HTMLSEV "<h6>$counter $sev_text{$sev} Event(s)<hr></h6>";
  }
  close(HTMLSEV);

  print HTMLEVENT "</table><hr><font size=1>($events_counter Event(s))</font>";
  if ($events_optional_text)
  {
    print HTMLEVENT "<br><b><font size=1>($events_optional_text $events_optional_num)</font></b>";
  }

  close(HTMLEVENT);
}

#-----------------------------------------------------------------------------
sub newAlpha
#-----------------------------------------------------------------------------
{
  $created_alpha{$alpha} = 1;

  if (! -e "/opt/dbamon/htm/alpha_$modelc")
  {
    mkdir("/opt/dbamon/htm/alpha_$modelc",755);
    system("ln -sf /opt/dbamon/htm/img /opt/dbamon/htm/alpha_$modelc/img > /dev/null 2>&1");
    system("ln -sf /opt/dbamon/htm/events_current_test /opt/dbamon/htm/alpha_$modelc/events_current > /dev/null 2>&1");
    system("ln -sf /opt/dbamon/htm/details_test /opt/dbamon/htm/alpha_$modelc/details > /dev/null 2>&1");
    system("ln -sf /opt/dbamon/htm/details_test /opt/dbamon/htm/alpha_$modelc/details_test > /dev/null 2>&1");
    system("ln -sf /opt/dbamon/htm/reports /opt/dbamon/htm/alpha_$modelc/reports > /dev/null 2>&1");
    system("ln -sf /opt/dbamon/htm/graphs /opt/dbamon/htm/alpha_$modelc/graphs > /dev/null 2>&1");
  }

  print HTMLALPHA &pageHeaderLocal("Instance Summary - Alpha=$alpha - Mode=$modeucfirst"); 

  print HTMLALPHA "<p><font face=$font size=3><b>Instance Detail - '$alpha' Server Instance(s):</font></b>\n" ;

  print HTMLALPHA "<table border=0>\n" ;

  print HTMLALPHA $g_detail_heading; 
}

#-----------------------------------------------------------------------------
sub instanceDetailAlpha
#-----------------------------------------------------------------------------
{
  &msg("instanceDetailAlpha() - Creating detail section");
  
### HERE
  $statement  = "select 
      system,
      title, 
      dbms, 
      ts, 
      --sysdate-ts,
      datediff(minute,ts,getdate()) 
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
    order by 2, 3";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg2 = 0;

  &msg("  (After select 1)");

  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    ##$age    = int($Data[4] * (60*24));    #Convert to minutes
    $age    = $Data[4];    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;
    $alpha  = uc substr($sytem,0,1);

    if ($title eq $last_title)
    {
      next; 
    }

    $dbms = "ServerNetAlias" if $dbms =~ /ServerAlias/;

    if ($alpha ne $last_alpha)
    {
      print HTMLALPHA "</table><p><font size=2><b>$alpha_i_count Total Instance(s)/Alias(es)</font><hr>\n" ;
      close(HTMLALPHA);
      if ($alpha_flag == 1)
      {
        $alpha_urls .= " <td align=right><h5>$alpha_i_count";
        chop($alpha_dbms_list);  # Remove trailing comma
        #$alpha_dbms_list =~ s/ //g;
        #$alpha_dbms_list =~ s/fontcolor/font color/g;
        $alpha_urls .= " <td><h5>$alpha_dbms_list\n";
        $alpha_dbms_list = "";
      }
      $alpha_flag = 1;
      $bg2 = &bg2;
      $alpha_urls .= "\n <tr $bg2><td align=center><a href='alpha_$modelc/$alpha.html'><h5>$alpha</a>";
      &newAlpha;
      $lastbg = 0;
      $alpha_i_count = 0;
    }
    $alpha_i_count++;
    if ($alpha_dbms_list !~ /$dbms/)
    {
      if ($dbms eq "Informix-UX     ") { $color = "darkblue" ; }
      if ($dbms eq "OracleDB-UX     ") { $color = "red"      ; }
      if ($dbms eq "OracleApps      ") { $color = "darkred"  ; }
      if ($dbms eq "SAP             ") { $color = "violet"   ; }
      if ($dbms eq "OracleDB-NT     ") { $color = "ff0090"   ; }
      if ($dbms eq "MSSQL           ") { $color = "green"    ; }
      if ($dbms eq "OSWin           ") { $color = "black"    ; }
      if ($dbms eq "ServerNetAlias")   { $color = "brown"    ; }

      $alpha_dbms_list .= "<font color=$color>$dbms</font>,";
    }
    
    $last_alpha = $alpha;

    $bg = &bg;
    print HTMLALPHA "<tr $bg height=$cell_height> $html <td nowrap $style_tiny><b>$task/$age</b>\n";
    $selectcount++;

    $last_title = $title;
  }

  $alpha_urls .= " <td align=right><h5>$alpha_i_count";
  print HTMLALPHA "</table><hr>\n" ;
  close(HTMLALPHA);
  chop($alpha_dbms_list);  # Remove trailing comma
  #$alpha_dbms_list =~ s/ //g;
  #$alpha_dbms_list =~ s/fontcolor/font color/g;
  $alpha_urls .= " <td><h5>$alpha_dbms_list\n";

  &msg("Selected $selectcount summary_detail rows - num_instances=$num_instances");
}

#-----------------------------------------------------------------------------
sub makeDetail
#-----------------------------------------------------------------------------
{
  &msg("Creating detail section");

  &instanceDetail;   # Create detailed portion - file is $detpath
  #---- 2011/01/20 BB - Move this higher up in the scorboard? Hmmm... I'll try it
  ##print HTML "<!--#include virtual='$detpath'-->\n";

  # Now count the number of rows in the tasks table for iteration 0. 
  # If the number of detail rows != the sum from the summary_dbms table,
  # then an update must be happening now!

  $statement  = "
    select 
      sum(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num = 0 
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $num_instances = $Data[0];
  }
  &msg("There are $num_instances instances from the task=0 dbamon.task table");

  #if ($num_instances != $selectcount)
  if ($num_instances > $selectcount)
  {
    ##&msg("The number of detail rows ($selectcount) does not match the count total ($num_instances)");
    ##&msg("from the summary_tasks table. Therefore, an update must be in process");
    ##&msg("now. Killing myself");
    ##exit 2;
    &error("Killing Myself - detail rows=$selectcount does not match the num_instances=$num_instances",2,1); 
  }
}

#-----------------------------------------------------------------------------
sub makeDetailShort
#-----------------------------------------------------------------------------
{
  $shortpath      = "/opt/dbamon/htm/tmp/instances${modelc}_$$.html.new";
  $shortpath_perm = "/opt/dbamon/htm/instances$modelc.html";

  &msg("cp'ing HTML");
  close(HTML);
  system("cp $html_sys_path_new $shortpath");
  ##system("ll $html_sys_path_new $shortpath");

  msg("Reopening output HTML file: $html_sys_path_new");
  open(HTML, ">>$html_sys_path_new") || &error("Cannot open input $html_sys_path_new - $!");

  &msg("Creating Short detail section");

  open(HTMLSHORT, ">>$shortpath") || &error("Cannot open output $shortpath - $!");

  &instanceDetailAlpha;

  print HTMLSHORT "<a name='ALPHA'>\n";
  print HTMLSHORT "<table width=$table_width>\n";
  print HTMLSHORT "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Instance Detail - By First Letter Of Server Name</center></font></b>\n";
  print HTMLSHORT "</table>\n";

  print HTMLSHORT "<table border=0 width=$table_width>
                    <tr bgcolor=slate>
                      <td align=center><h5>First<br>Letter Of<br>Server<br>Name
                      <td align=center><h5>Instance<br>Count
                      <td align=center><h5>DBMS(s)\n";
  print HTMLSHORT "$alpha_urls </table>\n";
  print HTMLSHORT "<font face=$font size=2><b><p>($server_count Total Server(s) - $health_tot Total Instance(s)/Alias(es) - $total_space gB Total DB Space)<hr>\n";

  &makeTasksShort;
}

#-----------------------------------------------------------------------------
sub makeFoot
#-----------------------------------------------------------------------------
{
  &msg("Creating foot section");

  open(HTMLTASK, ">$task_detail_file") || &error("Cannot open output $task_detail_file - $!");

  print HTMLTASK &pageHeaderLocal("Monitor Task Detail - Mode=$modeucfirst"); 

  print HTMLTASK "<p><font face=$font size=2><b>Monitor Task Detail:</font></b>\n" ;
  print HTMLTASK "<table $table_bgcolor border=0>\n" ;

  print HTMLTASK "<tr bgcolor=slate>
  <th $style_head>Monitor Process
  <th $style_head>Iteration<br>Number
  <th $style_head>Iteration<br>Duration<br>(Mins.)
  <th $style_head>Iteration<br>Completion<br>Time
  <th $style_head>PID
  <th $style_head>DB Server<br>Names / Classes<br>Monitored
  <th $style_head>Task Start Time
  <th $style_head>Number of <br>Instances<br> Monitored
  </tr>
  " ;

  $sql  = "
    select 
      dbamonmode, 
      pid,
      starttime_num,
      starttime_char,
      alpha,
      iter_num,
      iter_dur,
      num_instances,
      --to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\') 
      dbamon.dateconvert_19(ts)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    order by 
      1, 6";

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $pid   = $Data[1];
    #$st_n  = $Data[2];
    $st_c  = $Data[3];
    $alpha = $Data[4];
    $i_num = $Data[5];
    $i_dur = int($Data[6] / 60);
    $num   = $Data[7];
    $ctime = $Data[8];
 
    if ($i_mode ne $last_mode && $last_mode ne "")
    {
      print HTMLTASK "<tr><td colspan=8><hr>\n";
    }

    $bg = &bg;
    if ($i_mode ne $last_mode)
    {
      print HTMLTASK "<tr $bg $style_med>
       <td >$i_mode 
       <td align=right>$i_num 
       <td align=right>$i_dur 
       <td>$ctime 
       <td>$pid 
       <td>$alpha 
       <td>$st_c 
       <td align=right>$num 
      \n";
    }
    else
    {
      print HTMLTASK "<tr $bg $style_med>
       <td>$i_mode 
       <td align=right>$i_num 
       <td align=right>$i_dur 
       <td>$ctime 
       <td><td><td><td align=right>$num
      \n";

    }
    $selectcount++;
    $last_mode = $i_mode;
  }

  print HTMLTASK "</table><hr>\n" ;
  close(HTMLTASK);
}

#-----------------------------------------------------------------------------
sub makeIsolateMenu
#-----------------------------------------------------------------------------
{
  if ($isolated_urls ne "")
  {
    &msg("Creating isolated tasks menu");
    $ztext = "<table width=$table_width>
     <tr bgcolor=darkblue><td colspan=30><font face=$font size=2 color=wheat><b><center>Event Isolation</center></font></b>
     <tr bgcolor=lightgrey><td bgcolor=slate width=10%><b><font size=2>MsgID(s):</font><td><font size=2> $isolated_urls </font>
     </table><hr>\n";

    print HTMLSHORT "$ztext";
    print HTML      "$ztext";
  }
}

#-----------------------------------------------------------------------------
sub makeColorLegend
#-----------------------------------------------------------------------------
{
  &msg("Creating color legend");
  $ztext = "<table $table_bgcolor width=$table_width>
   <tr bgcolor=darkblue><td colspan=30><font face=$font size=2 color=wheat><b><center>Instance Color Legend</center></font></b>
   <tr bgcolor=lightgrey>
     <td bgcolor=lime         width=12% align=center><font size=2> <b>No Events <b></font>
     <td bgcolor=lime         width=12% align=center><font size=2> <b>&gt=1 Notation Event(s)<b></font>
     <td bgcolor=mediumpurple width=12% align=center><font size=2> <b>&gt=1 Security Event(s)<b></font>
     <td bgcolor=lightskyblue width=12% align=center><font size=2> <b>&gt=1 Performance Event(s)<b></font>
     <td bgcolor=#99cc00      width=12% align=center><font size=2> <b>&gt=1 User Event(s)<b></font>
     <td bgcolor=slateblue    width=12% align=center><font size=2> <b>&gt=1 Info Event(s)<b></font>
     <td bgcolor=yellow       width=12% align=center><font size=2> <b>&gt=1 Warning Event(s)<b></font>
     <td bgcolor=red          width=12% align=center><font size=2> <b>&gt=1 Critical Event(s)<b></font>
   </table><hr>\n";

  print HTMLSHORT "$ztext";
  print HTML      "$ztext";
}

#-----------------------------------------------------------------------------
sub makeTasksShort
#-----------------------------------------------------------------------------
{
  &msg("Creating tasks section");

  print HTMLSHORT "<table $table_bgcolor width=$table_width>\n";
  print HTMLSHORT "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Monitor Task Summary</center></font></b>\n";
  print HTMLSHORT "</table>\n";
  
  print HTMLSHORT "<table $table_bgcolor width=$table_width border=0>\n" ;

  print HTMLSHORT "<tr bgcolor=slate>\n" ;
  print HTMLSHORT "<th $style_med>Monitor<br>Process\n" ;
  print HTMLSHORT "<th $style_med>Instances/<br>Classes<br>Being<br>Monitored\n" ;
  print HTMLSHORT "<th $style_med>Last<br> Iteration <br># Completed\n" ;
  print HTMLSHORT "<th $style_med>Avg. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th $style_med>Min. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th $style_med>Max. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th $style_med>Avg. Number of <br>Instances<br>Monitored\n" ;
  print HTMLSHORT "<th $style_med>Avg. Duration<br>Per Instance<br>(Mins.)\n" ;
  print HTMLSHORT "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      alpha,
      max(iter_num),
      avg(iter_dur),
      min(iter_dur),
      max(iter_dur),
      avg(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num > 0
    group by
      dbamonmode,
      alpha
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;

  $total_num = 0;
  $total_min = 99999;
  $total_max = 0;
  $total_cnt = 0;
  $total_avg = 0;
  $total_avgdur = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $i_alph= $Data[1];
    $i_num = $Data[2];
    $i_dur = int($Data[3] / 60);
    $i_min = int($Data[4] / 60);
    $i_max = int($Data[5] / 60);
    $num   = sprintf("%7.1f",$Data[6]);
    $avgper= sprintf("%7.2f",$i_dur/$num);

    $bg = &bg;

    $mode_url = "<a href='/cgi-bin/dbamon_mode.pl?$i_mode'>$i_alph</a>"; 

    if    ($i_dur >= 90) { $dur_color = "pink"; } 
    elsif ($i_dur >= 60) { $dur_color = "yellow"; } 
    else                 { $dur_color = "lime"; } 

    print HTMLSHORT "
    <tr $bg>
      <td><h5>$i_mode 
      <td><h5>$mode_url
      <td $style_med align=right><b>$i_num </b>
      <td $style_med align=right bgcolor=$dur_color><b>$i_dur </b>
      <td $style_med align=right><b>$i_min </b>
      <td $style_med align=right><b>$i_max  </b>
      <td $style_med align=right><b>$num  </b>
      <td $style_med align=right><b>$avgper  </b>
    \n";
    $selectcount++;
    $num_instances += $num;
    
    $total_num += $i_num;
    $total_cnt += $num;
    $total_avg += $avgper;
    $total_min = $i_min if $i_min < $total_min;
    $total_max = $i_max if $i_max > $total_max;
    $total_avgdur += $i_dur;
  }

  $total_avg = $total_avg / $selectcount if $selectcount > 0;
  $total_avgdur = int($total_avgdur / $selectcount) if $selectcount > 0;

  $total_cnt = sprintf("%7.1f",$total_cnt);
  $total_avg = sprintf("%7.2f",$total_avg);

  print HTMLSHORT "<tr bgcolor=slate>\n" ;
  print HTMLSHORT "<th align=left><h5>Total:\n" ;
  print HTMLSHORT "<th ><h5>\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_num\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_avgdur\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_min\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_max\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_cnt\n" ;
  print HTMLSHORT "<th align=right ><h5>$total_avg\n" ;

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $color = "lime"; 

  $endmsg2  = "No tasks have reported - DBAmon is starting";
  $taskflag1 = 1;

  while (@Data = $sth->fetchrow_array)
  {
    $taskflag1 = 0;
    $endmsg2  = "Since all tasks have completed >=1 iteration, this page is complete";

    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    if ($i_num < 1) 
    {
      $endmsg1 .= "Task=$i_mode has not yet completed 1st iteration<br>";
      $endmsg2  = "This page is not yet complete";
      $color = "red";
      $taskflag2 = 1;
    }
  }

  # Experiment - if page is not complete, then die
  if ($taskflag1 || $taskflag2)  
  {
    &msg("Page not complete - Exiting - taskflag1=$taskflag1 taskflag2=$taskflag");
    exit 0;
  }

  print HTMLSHORT "<tr><td colspan=8 bgcolor=$color align=center><h5>$endmsg1 $endmsg2 \n";
  ##print HTMLSHORT "</form>\n" ;
  print HTMLSHORT "</table>\n" ;
  print HTMLSHORT "<ul><li><b><span $style_med><a href='$task_detail_url'>Monitor Task Details</a></ul>\n" ;
  print HTMLSHORT "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub makeTasks
#-----------------------------------------------------------------------------
{
  &msg("Creating tasks section");

  print HTML "<table $table_bgcolor width=$table_width>\n";
  print HTML "<tr bgcolor=darkblue><td><font face=$font size=2 color=wheat><b><center>Monitor Task Summary</center></font></b>\n";
  print HTML "</table>\n";
  
  print HTML "<table $table_bgcolor border=0 width=$table_width>\n" ;

  print HTML "<tr bgcolor=slate>\n" ;
  print HTML "<th $style_head>Monitor Process\n" ;
  print HTML "<th $style_head>Instances/<br>Classes<br>Being<br>Monitored\n" ;
  print HTML "<th $style_head>Last<br> Iteration <br># Completed\n" ;
  print HTML "<th $style_head>Avg. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th $style_head>Min. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th $style_head>Max. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th $style_head>Avg. Number of <br>Instances<br>Monitored\n" ;
  print HTML "<th $style_head>Avg. Duration<br>Per Instance<br>(Mins.)\n" ;
  print HTML "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      alpha,
      max(iter_num),
      avg(iter_dur),
      min(iter_dur),
      max(iter_dur),
      avg(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num > 0
    group by
      dbamonmode,
      alpha
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $i_alph= $Data[1];
    $i_num = $Data[2];
    $i_dur = int($Data[3] / 60);
    $i_min = int($Data[4] / 60);
    $i_max = int($Data[5] / 60);
    $num   = sprintf("%7.1f",$Data[6]);
    $avgper= sprintf("%7.2f",$i_dur/$num);

    $bg = &bg;

    $mode_url = "<a href='/cgi-bin/dbamon_mode.pl?$i_mode'>$i_alph</a>"; 

    print HTML "
      <tr $bg>
        <td $style_med ><b>$i_mode  </b>
        <td $style_med ><b>$mode_url </b>
        <td $style_med align=right><b>$i_num  </b>
        <td $style_med  align=right><b>$i_dur  </b>
        <td $style_med  align=right><b>$i_min </b>
        <td $style_med  align=right><b>$i_max  </b>
        <td $style_med  align=right><b>$num  </b>
        <td $style_med  align=right><b>$avgper  </b>
    \n";

    $selectcount++;
    $num_instances += $num;
  }

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $color = "lime"; 

  $endmsg2  = "No tasks have reported - DBAmon is starting";
  $taskflag1 = 1;

  while (@Data = $sth->fetchrow_array)
  {
    $taskflag1 = 0;
    $endmsg2  = "Since all tasks have completed >=1 iteration, this page is complete";

    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    if ($i_num < 1) 
    {
      $endmsg1 .= "Task=$i_mode has not yet completed 1st iteration<br>";
      $endmsg2  = "This page is not yet complete";
      $color = "red";
      $taskflag2 = 1;
    }
  }

  # Experiment - if page is not complete, then die
  if ($taskflag1 || $taskflag2)  
  {
    &msg("Page not complete - Killing myself - taskflag1=$taskflag1 taskflag2=$taskflag");
    exit 1;
  }

  print HTML "<tr><td colspan=8 bgcolor=$color $style_med><b>$endmsg1 $endmsg2 </b>\n";
  ##print HTML "</form>\n" ;
  print HTML "</table>
  <$style_med>
  <ul>
    <li><b><a href='$task_detail_url'><$style_med>Monitor Task Details</a>
  </ul>
  </span>
  <hr>
  ";
}

#-----------------------------------------------------------------------------
sub checkTasks
#-----------------------------------------------------------------------------
{
  # See if all tasks have completed the first iteration - if not, then die

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $tasks_starting = 0;
  $tasks_count    = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $tasks_count++;
    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    ##print "task=$i_mode maxiter=$i_num\n";

    if ($i_num < 1) 
    {
      $taskflag3 = 1;
      $tasks_starting++;
    }
  }

  if ($taskflag3)  
  {
    ## system("echo '<font color=red>Starting</font>' > /opt/dbamon/htm/status_$modelc.txt");  
    &error("DBAmon $tasks_starting/$tasks_count Tasks Starting - Killing myself - taskflag3=$taskflag3 tasks_count=$tasks_count tasks_starting=$tasks_starting",2);
  }

  &msg("All mode=$modelc tasks appear to have completed iteration #1");
}

#-----------------------------------------------------------------------------
sub reportMenu
#-----------------------------------------------------------------------------
{
  &msg("Creating report menu");

  # make sure dir exists
  if (! -x "/opt/dbamon/htm/reports/")
  {
    system("mkdir /opt/dbamon/htm/reports/");
  }

  $rpt_dbtime = 0;

  foreach (@instance_list)
  {
    s/ //g;
    $inst = $_;
    $instuc = uc $inst;
    ##&msg("Found instance=$inst");

    $zsrvr = (split(":",$inst)) [0];
    $zinst = (split(":",$inst)) [1];

    $b4 = time;

    $statement = "select dbms, dbmsver from dbamon.instances 
                  where system like '$zsrvr%' 
                    and instance = '$zinst' 
                    and dbamonmode like '%${modelc}%'";
    $sth = $dbh->prepare($statement) || &error('Select_$what');
    $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
    $selectcount = 0;
    $dbms = "?";
    $dver = "?";
    while (@Data = $sth->fetchrow_array)
    {
      $selectcount++;
      ($dbms = $Data[0]) =~ s/ //g;
      ($dver = $Data[1]) =~ s/ //g;
    }

    $rpt_dbtime += (time - $b4);

    $dver = substr($dver,1) if $dver =~ /^0/;

    $ver1 = substr($dver,0,1);

    if    ($dbms eq "Oracle" && $ver1 ge "8") { $incfile = "inc1"; }
    elsif ($dbms eq "Oracle" && $ver1 lt "8") { $incfile = "inc2"; }
    else                                      { $incfile = "inc3"; }

    $zinstuc = uc $zinst;

    &msg("dbms=$dbms dver=$dver ver1=$ver1 incfile=$incfile zsrvr=$zsrvr zinst=$zinst");

    # build menu 
    $html_template = `cat /opt/dbamon/lib/$P.$incfile.html`;
    $html_template =~ s/INSTANUC/$instuc/g;
    $html_template =~ s/INSTANCE/$inst/g;
    $html_template =~ s/MODE/$modelc/g;
    $html_template =~ s/SERVER/$zsrvr/g;
    $html_template =~ s/DBNAME/$zinst/g;
    $html_template =~ s/DBNAUC/$zinstuc/g;

    $file = "/opt/dbamon/htm/reports/$inst.html";
    open(RPTINST, ">/opt/dbamon/htm/reports/$inst.html") || &error("Cannot open output $file - $!");
    print RPTINST "$html_template";
    close(RPTINST); 
    $menucount++;
  }
  &msg("Created $menucount report menus - rpt_dbtime=$rpt_dbtime");
}

#----------------------------------------------------------------------
sub readRC
#----------------------------------------------------------------------
{
  $my_verb = $_[0];
  $my_dbamonrc = "/opt/dbamon/adm/dbamonrc";
  $my_rval = ""; 
  my $readrc_debug = 0; 

  &msg("readRC - Looking for dbamonrc value for $my_verb") if $readrc_debug;

  open(RC,"$my_dbamonrc") || &error("Cannot open input $my_dbamonrc - $!");
  while(<RC>)
  {
    next if /^#/;
    next if /^$/;
    @my_words = split;
    if (uc $my_words[0] eq uc $my_verb) { $my_rval = $my_words[1]; last; }
  }
  close(RC);

  &msg("readRC - Returning: $my_rval") if $readrc_debug;
  return $my_rval;
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  &msg("init - Starting"); 

  if ($mode eq "PROD")
  {
    #$cmd = "$pscmd | grep $P | grep -v grep";
    #&msg("Ensuring that only 1 copy of $P is running... - cmd=$cmd");
    #system($cmd);
    #chop($numproc = `$cmd | wc -l`);

    &msg("Ensuring that only 1 copy of $P is running...");
    $numproc = 0; 
    open(CMD,"$pscmd |") || &error("Cannot run $pscmd"); 
    while(<CMD>)
    {
      print if /$P/;
      $numproc++ if /$P/; 
    }
    close(CMD); 

    &msg("Number of ${P}'s for mode=$mode running: $numproc");
    if ($numproc > 2)
    {
      &msg("There is another instance of $P running - numproc=$numproc - killing myself");
      exit 2; 
    }
  }

  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
    chop($dbc_count = `ls -l /opt/dbamon/adm/instances_test/*.dbc | wc -l`);
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
    chop($dbc_count = `ls -l /opt/dbamon/adm/instances/*.dbc | wc -l`);
  }
  &msg("DBC File Count: $dbc_count");

  &msg("rm'ing old .new files - Usage error message is OK");
  system("find /opt/dbamon/htm/tmp/*.new -mtime +1 | xargs rm");

  #---- New way
  $id1_breakout = &readRC("ID1_Breakout:"); 
  $id2_breakout = &readRC("ID2_Breakout:"); 
  $id3_breakout = &readRC("ID3_Breakout:"); 
  $id4_breakout = &readRC("ID4_Breakout:"); 
  $id5_breakout = &readRC("ID5_Breakout:"); 
  $id6_breakout = &readRC("ID6_Breakout:"); 
  $id7_breakout = &readRC("ID7_Breakout:"); 
  $id8_breakout = &readRC("ID8_Breakout:"); 
  $id9_breakout = &readRC("ID9_Breakout:"); 
  $id10_breakout = &readRC("ID10_Breakout:"); 
  $id11_breakout = &readRC("ID11_Breakout:"); 
  $id12_breakout = &readRC("ID12_Breakout:"); 
  $id13_breakout = &readRC("ID13_Breakout:"); 
  $id14_breakout = &readRC("ID14_Breakout:"); 
  $id15_breakout = &readRC("ID15_Breakout:"); 
  $id16_breakout = &readRC("ID16_Breakout:"); 
  $id17_breakout = &readRC("ID17_Breakout:"); 
  $id18_breakout = &readRC("ID18_Breakout:"); 
  $id19_breakout = &readRC("ID19_Breakout:"); 
  $id20_breakout = &readRC("ID20_Breakout:"); 

  $loc_breakout = &readRC("Loc_Breakout:"); 
  $events_isolate = &readRC("WWW_Event_Isolate:"); 

  #---- Read WWW_Check:
  ##chop($font = `grep 'WWW_Font:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  $font = &readRC("WWW_Font:"); 
  if ($font =~ /%/)
  {
    $font =~ s/%/ /g;
    $font = "'$font'";
  }
  ##$font = "tahoma"; 
  msg("font=$font  ");
  
  chop($verrel        = `cat /opt/dbamon/bin/verrel`);
  chop($startdate     = `cat /opt/dbamon/adm/startdate_${modelc}.txt`);

  ##msg("html_sys_path=$html_sys_path  ");

  chop($hostname = `hostname`);
  ##chop($date = `date`);
  $date = &getdate; 

  #$html_sys_path_new = "${html_sys_path}.$$.new";
  $html_sys_path_new = "/opt/dbamon/htm/tmp/syspath_${modelc}_$$.html.new";
  msg("Opening output HTML file: $html_sys_path_new");
  system("mkdir /opt/dbamon/htm/tmp > /dev/null 2>&1");
  open(HTML, ">$html_sys_path_new") || &error("Cannot open output $html_sys_path_new - $!");

  $task_detail_file = "/opt/dbamon/htm/task_detail_${modelc}.html";
  $task_detail_url  = "task_detail_${modelc}.html";

  if ($modelc eq "test") { $detpath = "instance_detail_test.html"; }
  else                   { $detpath = "instance_detail.html"; }

  $links_include = `cat /opt/dbamon/lib/trans_links.txt`;

  #chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  $date = &getdate; 

  $links = "
    <table width=$table_width>

    $links_include

    <tr bgcolor=lightgrey align=center>
      <td colspan=30><span style='font-family:$font; font-size:8pt;'>
      <i>
        DBAmon was last started: $startdate -
        Page generated by DBAmon version
          <a HREF='http://dbamon.com/misc/change_history.shtml'><b>$verrel</b></a> mode=$mode
          on Master=$hostname at <b>$date</b>
      </i></font>
    </table>
  ";
  if ($modelc eq "test") 
  { 
    $links =~ s/alpha_prod/alpha_test/g; 
  }

  if (-e "/var/log/apache2/ssl_request_log") 
  {
    $gadget_urlprefix = "https://$hostname/dbamon"; 
  }
  else
  {
    $gadget_urlprefix = "http://$hostname/dbamon"; 
  }

  $f_s_med = "<span style='font-family:$font; font-size:9pt;'>"; 
  $style_tiny = "span style='font-family:$font; font-size:8pt;'"; 
  $style_med  = "span style='font-family:$font; font-size:10pt;'"; 
  $style_head  = "span style='font-family:$font; font-size:9pt;'"; 
  $style_large  = "span style='font-family:$font; font-size:11pt;'"; 

  #---- Create the new one and only DETAIL HEADER
  ## <th $style_head>Available<br><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>
  $g_detail_heading = "
<tr bgcolor=slate>
  <th colspan=2 $style_head>Server/Instance Identity
    <br>DBC Title1<sub>T1</sub> Title2<sub>T2</sub> ... Tag: 
    <br>DBC ID1<sub>I1</sub> ID2<sub>I2</sub> ID3<sub>I3</sub> ...
  <th $style_head>Current<br>Server<br>Metrics
  <th $style_head>DBMS/OS/App<br>Info.
  <th $style_head>Available<br>Actions/Reports
  <th $style_head width=15%>Outstanding DBAmon Events<br>(If Any)
  <th $style_head>Status Flags
  <th $style_head>DB Backup Info.
  <th $style_head>Instance/ Server/ Config Info.
  <th $style_head>Task/Entry<br>Age<br>Mins.
</tr>
  "; 

  &msg("init - Done"); 
}

#------------------------------------------------------------------------------
sub pageHeaderLocal
#------------------------------------------------------------------------------
{
  my $ph_title   = $_[0];
  my $ph_refresh = $_[1];

  my $ph_title_font = "verdana"; 

  $ph_refresh = 86400 if ! $ph_refresh;

  my $ph_content = " 
<title>DBAmon $ph_title - Mode: $mode</title>
<meta http-equiv=Refresh content=$ph_refresh>
<link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>
<body bgcolor=white link=darkblue vlink=darkblue>
<font face=$font>
<table width=$table_width bgcolor=wheat>
<tr bgcolor=darkblue>
  <td align=center valign=center style='font-family:verdana;font-size:48;color:white;'>DBAmon 
<tr bgcolor=wheat>
  <td>
    <span style='font-family:$ph_title_font; font-size:15pt;'>
    <center>$ph_title</center>
</table>
$links
<hr>
  ";  
  return $ph_content;
}

#------------------------------------------------------------------------------
sub dbamonrcLabel
#------------------------------------------------------------------------------
{
  my $thisid = $_[0];
  #---- Read IDx_Label parms
  ##chop($dl_label_raw = `grep 'ID${thisid}_Label:' $rcfile | grep -v '^#'`);
  $dl_label_raw = &readRC("ID${thisid}_Label:"); 
  my @zwords = split(" ",$dl_label_raw);
  my $dl_label = substr($dl_label_raw,index($dl_label_raw,$zwords[1])); 
  ##msg("thisid=$thisid dl_label=$dl_label");

  return $dl_label;
}
  
#------------------------------------------------------------------------------
sub missingAlpha
#------------------------------------------------------------------------------
{
  foreach $letter (A..Z)
  {
    if (! $created_alpha{$letter})
    {
      &msg("Creating null alpha page: $letter");

      open(HTMLALPHA, ">/opt/dbamon/htm/alpha_$modelc/$letter.html") || &error("Cannot open output /opt/dbamon/htm/alpha_$modelc/$letter.html - $!");

      print HTMLALPHA &pageHeaderLocal("Monitor Task Detail - Alpha=$letter - Mode=$modeucfirst"); 

      print HTMLALPHA "<p><font face=$font size=3><b>Instance Detail - '$letter' - NO Instances</font></b>\n" ;
      close HTMLALPHA; 
    }
  }
}

#------------------------------------------------------------------------------
sub makeID
#------------------------------------------------------------------------------
{
  #if ($id1_breakout eq "Y")
  #{
  #  foreach $id1 (@id1list) #  { #    &makeDetailID1($id1); #  }
  #}

  #if ($id2_breakout eq "Y")
  #{
  #  foreach $id2 (@id2list) { &makeDetailID2($id2); }
  #}

  #if ($id3_breakout eq "Y")
  #{
  #  foreach $id3 (@id3list) { &makeDetailID3($id3); }
  #}

  #if ($id4_breakout eq "Y")
  #{
  #  foreach $id4 (@id4list) { &makeDetailID4($id4); }
  #}

  #if ($id5_breakout eq "Y")
  #{
  #  foreach $id5 (@id5list) { &makeDetailID5($id5); }
  #}

  #if ($id6_breakout eq "Y")
  #{
  #  foreach $id6 (@id6list) { &makeDetailID6($id6); }
  #}

  #if ($id7_breakout eq "Y")
  #{
  #  foreach $id7 (@id7list) { &makeDetailID7($id7); }
  #}

  #if ($id8_breakout eq "Y")
  #{
  #  foreach $id8 (@id8list) { &makeDetailID8($id8); }
  #}

  #if ($id9_breakout eq "Y")
  #{
  #  foreach $id9 (@id9list) { &makeDetailID9($id9); }
  #}

  #if ($id10_breakout eq "Y")
  #{
  #  foreach $id10 (@id10list) { &makeDetailID10($id10); }
  #}

}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("=============================================================================================");
&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 - version=$version");

&msg("Connecting to repository"); 
&connectDB(1);
&init;

&checkTasks;

&makeTitle; 
&makeScoreboard; 

&makeDetailShort if $alpha_make; 

&makeDetail; 

&makeTasks; 
&makeFoot; 

&makeSev;

foreach $dbms (@dbmslist)
{
  &makeDetailDBMS($dbms); 
}

#---- Do NOT do this any more - it is done by the IDVal routines
### &makeID;

if ($loc_breakout eq "Y")
{
  foreach $loc (@loclist) { &makeDetailLOC($loc); }
}

# Make menu of isolated events
&makeColorLegend;

# Make menu of isolated events
&makeIsolateMenu;

# Create dummy page(s) for missing alphas
&missingAlpha if $alpha_make;

&msg("Closing HTML filehandle");
close(HTML);
close(HTMLSHORT);

&msg("Renaming $html_sys_path_new to $html_sys_path");
$rc = system("mv $html_sys_path_new $html_sys_path"); 
if ($rc != 0) 
{
  &error("Error renaming $html_sys_path_new to $html_sys_path");
}

if (-e "$shortpath") 
{
  &msg("Renaming $shortpath to $shortpath_perm");
  $rc = system("mv $shortpath $shortpath_perm"); 
  if ($rc != 0) 
  {
    &error("Error renaming $shortpath to $shortpath_perm");
  }
}

# Just in case
system("rm $html_sys_path_new > /dev/null 2>&1"); 

#---- These are OFF for now - 2010/12/22 BB

if (1 == 0)
{
  &msg("Invoking dbamon_uptime_summarize");
  chop($dow = `date +%a`);
  system("dbamon_uptime_summarize >> /opt/dbamon/log/downtime/dbamon_uptime_summarize_${dow}.log 2>&1");

  &msg("Invoking dbamon_qc");
  system("dbamon_qc.pl > /opt/dbamon/log/dbamon_qc.log 2>&1 &");
}

#---- BB 06Dec07 Moved this to cron
#&msg("Invoking dbamon_ora_util eventCleanup");
#system("echo 'dbamon_ora_util prod eventCleanup >> /opt/dbamon/log/dbamon_eventCleanup.log 2>&1' | at now");

&msg("Writing to asof files"); 
$date = &getdate; 
system("echo '$date' > /opt/dbamon/htm/asof_$modelc.txt");
chop($size = `ls -l /opt/dbamon/htm/$detpath | awk '{ print \$5 }'`);
system("echo '$size' > /opt/dbamon/htm/sizeof_$modelc.txt");

#---- NO NEED to do this any more 
#---- Copy email data to EMAIL table
## &emailCopy;

#---- NO NEED to do this any more - graphs are now dynamic
#---- Create report menus
## &reportMenu;

$num_instances /= 2;
system("echo '$date - $mode - $num_instances' >> $log");
system("echo '<font color=lime>Running as of $date - $task_count Task(s) Running</font>' > /opt/dbamon/htm/status_$modelc.txt");  

#---- Log the instance count and health setting to a file in /opt/dbamon/dat
&logToFile;

system("chmod -R 755 /opt/dbamon/htm"); 
&msg("Done");
exit 0;
