#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_qc.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}

$| = 1;
$P = "dbamon_qc.pl";
$tmpfl  = "/tmp/${P}_$$.txt";

$htmlqc   = "/opt/dbamon/htm/qc_insync.html";
$htmlev   = "/opt/dbamon/htm/qc_events.html";
$htmlfl   = "/opt/dbamon/htm/qc_new.html";
$htmlperm = "/opt/dbamon/htm/qc.html";

$grep = "OPR1|PPR1|SPR1|SPR2|FDB01|GMDSDB|GHRMSDB";
$rows = 250;
$img = "http://theserver.cos.thecompany.com/images/blue.gif";
$file = "/opt/dbamon/dat/history/insync.dat";

chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
$ENV{'ORACLE_SID'}  = $ORACLE_SID;
$ENV{'ORACLE_HOME'} = $ORACLE_HOME;
$old_path           = $ENV{"PATH"};
$ENV{'PATH'}        = "$ORACLE_HOME/bin:${old_path}";

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$mode = uc $ARGV[0];
if ($mode eq "") { $mode = "prod"; }
$modelc = lc $mode;

$except_count = 0;

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
$arg5 = $ARGV[5];
$arg6 = $ARGV[6];
$arg7 = $ARGV[7];
$arg8 = $ARGV[8];

if ($modelc ne "test" && $modelc ne "prod")
{
  print "$P | Usage: $0 {test | prod}\n";
  exit 1;
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = @_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = @_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}


#------------------------------------------------------------------------------
sub inSyncReport
#------------------------------------------------------------------------------
{
  @alldata = `grep '^$instance' $file | sort -r | head -25`;

  ##print "count=$#alldata\n";

  print HTMLQC "<font size=2><b>Instance: $instance</b></font>
  <a name='$instance'>
  <p>\n";

  print HTMLQC "<table border=1>
  <tr bgcolor=slate>
    <th><h5>Date
    <th colspan=2><h5>Standby vs. Primary Delta (Minutes)\n";

  $count = 0;

  foreach (@alldata)
  {
    @words = split;
    $thisdate = $words[1];
    $value    = $words[2];

    $value = 0 if $value < 0;

    print HTMLQC "<tr>
      <td nowrap><font size=2>$thisdate</font>
      <td nowrap><font size=2><b>$value</font>
      <td nowrap><img src='$img' height=15 width=$value>
    \n";
    last if (++$count > $rows);
  }
  print HTMLQC  "</table><p>\n";
}


#------------------------------------------------------------------------------
sub inSyncListDBs
#------------------------------------------------------------------------------
{
  @instances = `cat $file | egrep '$grep' | awk '{ print \$1 }' | sort -u`;
}


#-----------------------------------------------------------------------------
sub bkNone
#-----------------------------------------------------------------------------
{
  &msg("bkNone - Selecting");

  $statement  = "
    select distinct
      system,
      instance,
      misc1,
      dbmsver
    from 
      dbamon.instances
    where
      misc1 = 'bkNone' and
      dbamonmode like 'prod%' and
      misc2 is null
    order by 1,2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select_$what');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $serv = $Data[0];
    $inst = $Data[1];
    $meth = $Data[2];
    $ver  = $Data[3];
  
    $_ = "$serv:$inst";
    s/ //g;
    $title = $_;
    
    print HTML "
    <tr>
      <td><font size=2 color=red><b>Derived Oracle Backup Type: bkNone</b>
      <td><font size=2>Instance: <b>$title</b>
      <td><font size=2>Oracle Version: <b>$ver</b>
    ";
    $except_count++;
  }

  &msg("bkNone - Selected $selectcount rows");
}


#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  chop($hostname = `hostname`);
  chop($date = `date`);

  msg("Opening output HTML file: $htmlfl");
  open(HTML, ">$htmlfl") || &error("Can't open output $htmlfl - $!");

  $links_include = `cat /opt/dbamon/lib/trans_links.txt`;
  $head_top      = `cat /opt/dbamon/htm/inc/head_top.html`;

  print HTML "
    <head><title>DBAmon Quality Control</title></head>
    $head_top
    <font face=$font>
    <tr bgcolor=wheat width=750><td align=center>
    <font size=5>DBAmon Quality Control (QC)</font>
    </table><table width=750>
    $links_include
    </table>
    <hr>

  ";
}

#------------------------------------------------------------------------------
sub inSync
#------------------------------------------------------------------------------
{
  # Report on standby DB's over the last 7 days
  &inSyncListDBs;

  msg("Opening output HTML file: $htmlfl");
  open(HTMLQC, ">$htmlqc") || &error("Can't open output $htmlqc - $!");
  print HTMLQC "<font face=$font>\n";

  foreach $instance (@instances)
  {
    chop $instance;
    &msg("inSyncReport - Processing instance=$instance");
    &inSyncReport;
  }
  close(HTMLQC);

  print HTML "
    <hr>
    <h4>Oracle/UX InSync Reports (25 Most Recent Observations):</h4>
    <iframe src='/dbamon/qc_insync.html' width=80% height=700> </iframe>
    ";
}

#------------------------------------------------------------------------------
sub exceptions
#------------------------------------------------------------------------------
{
  print HTML "<h4>Quality Exceptions:</h4>";
  print HTML "<table border=1 bgcolor=skyblue>
    <tr bgcolor=slate>
      <th><font size=2>Quality Exception 
      <th colspan=8><font size=2>Details
    ";

  &bkNone; 

  print HTML "
    </table>
    <h4>Total Quality Exception count: $except_count</h4>
    ";
}


#-----------------------------------------------------------------------------
sub events24Hours
#-----------------------------------------------------------------------------
{
  &msg("events24Hours - Selecting");

  print HTMLEV "<a name=rpt24>\n";
  print HTMLEV "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last 24 Hours </h5>\n";

  print HTMLEV "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print HTMLEV "<tr bgcolor=slate>
    <th><font size=2>Instance</font>
    <th><font size=2>Msgid</font>
    <th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      title,
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 1 
    group by
      title,
      msgid 
    order by
      3 desc";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title = $Data[0];
    $msgid = $Data[1];
    $count = $Data[2];

    $total += $count;

    $z = $count ;

    print HTMLEV "<tr>
       <td><font size=2>$title
       <td><font size=2>$msgid
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print HTMLEV "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print HTMLEV "</table>\n";

  $daytotal = $total;

  &msg("Selected $selectcount rows - daytotal=$daytotal");
}







#-----------------------------------------------------------------------------
sub events7Days
#-----------------------------------------------------------------------------
{
  &msg("events7Days - Selecting");

  print HTMLEV "<a name=rpt7>\n";
  print HTMLEV "<h5><hr>DBAmon Critical Event Summary - Grouped By Instance And MsgID - Last Week </h5>\n";

  print HTMLEV "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print HTMLEV "<tr bgcolor=slate>
    <th><font size=2>Instance</font>
    <th><font size=2>MsgId</font>
    <th colspan=2><font size=2>Event Count</font>\n";

  $statement  = "
    select
      title,
      msgid,
      count(*)
    from 
      dbamon.event_history
    where 
      ts >= sysdate - 7 
    group by
      title,
      msgid
    order by
      3 desc ";

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $total = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $title   = $Data[0];
    $msgid   = $Data[1];
    $count   = $Data[2];

    $total += $count;

    $z = $count;

    print HTMLEV "<tr>
       <td><font size=2>$title
       <td><font size=2>$msgid
       <td align=right><font size=2>$count  
       <td><img src='$img' height=15 width=$z>
         </font>
    \n";
  }

  print HTMLEV "<tr bgcolor=slate><td><font size=2><b>Total:<td align=right><font size=2>$total\n";
  print HTMLEV "</table>\n";

  &msg("Selected $selectcount rows");
}



#-----------------------------------------------------------------------------
sub eventsMsgID
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  print HTMLEV "<a name=rptmsgid>\n";
  print HTMLEV "<h5><hr>DBAmon MsgId Legend - Examples</h5>\n";

  print HTMLEV "<table border=1 bgcolor=white bordercolor=white bordercolorlight=gray bordercolordark=white  >\n";
  print HTMLEV "<tr bgcolor=slate>
    <th><font size=2>MsgId</font>
    <th><font size=2>Example Text</font>\n";

  $statement  = "
select
  msgid,
  min(text)
from 
  dbamon.event_history
group by
  msgid
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $msgid = $Data[0];
    $text  = $Data[1];

    printf HTMLEV "<tr>
      <td><font size=2>$msgid
      <td><font size=2>$text
       \n";

  }

  print HTMLEV "</table>\n";

  &msg("Selected $selectcount rows");
}

#------------------------------------------------------------------------------
sub events
#------------------------------------------------------------------------------
{
  msg("Opening output HTML file: $htmlev");
  open(HTMLEV, ">$htmlev") || &error("Can't open output $htmlev - $!");
  print HTMLEV "<font face=$font>\n";

  print HTMLEV "
    <ul>
      <font size=2>
      <li><a href='#rpt24'><b>Critical Events During the Last 24 Hours - By Instance And MsgId</b></a>
      <li><a href='#rpt7'><b>Critical Events During the Last 7 Days - By Instance And MsgId</b></a>
      <li><a href='#rptmsgid' ><b>DBAmon MsgId Legend</b></a>
    </ul>
    ";

  &events24Hours; 
  &events7Days; 
  &eventsMsgID; 

  close(HTMLEV);
  print HTML "
    <hr>
    <h4>Recent Event Reports:</h4>
    <iframe src='/dbamon/qc_events.html' width=80% height=700> </iframe>
    ";
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");


&msg("This program is NO-OP'd for now"); 
exit;


&connectDB;
&init;

# Exceptions
&exceptions;

# Insync
&inSync;

# Events
&events;

&msg("Closing and switching HTML");
print HTML " <hr> <font size=1>As of: $date</font> ";
close(HTML);
system("mv $htmlfl $htmlperm");

&msg("Done");
exit 0;
